#include <stdio.h>
#include <stdlib.h>
#include "structures.h"
#include "case.h"
#include "personnage.h"
#include "deplacements.h"

/*!
* \file deplacements.c
* \brief Fichier contenant le code des fonctions liees aux dplacements des personnages.
*/

/*!
 * \fn boolean case_a_cote(Personnage * perso, Case * destination)
 * \brief La fonction vrifie que la case hexagonale "destination" est contigue  la case du personnage
 *
 * \param Un personnage, une case
 * \return Un booleen.
 */
boolean case_a_cote(Personnage * perso, Case * destination){
    Case *depart = getPosition(perso);
    if (get_x(depart)>get_x(destination)+1||get_x(depart)<get_x(destination)-1||get_y(depart)>get_y(destination)+1||get_y(depart)<get_y(destination)-1){
        return faux;
    }
    if (get_y(depart)==get_y(destination)+1&&get_x(depart)!=get_x(destination)){
        return faux;
    }
    return vrai;
}

/*!
 * \fn deplacement_unitaire(Personnage *perso,Case * destination)
 * \brief dplace un personnage sur une case situe  ct de la sienne, si cela est possible
 *
 * \param Un personnage, une case
 * \return Un entier.
 */
int deplacement_unitaire(Personnage *perso,Case * destination){
    if (est_occupee(destination)==vrai){
        printf("deplacement impossible : case deja occupee par un personnage\n");
        return 1;
    }
    if (case_franchissable(destination)==faux){
        printf("dplacement impossible : case infranchissable");
        return 1;
    }
    if (case_a_cote(perso,destination)==vrai){
       return deplacer_personnage(perso, destination);
    }
    printf("deplacement impossible : case non contigue\n");
    return 1;
}



/* Cette fonction devrait plutot renvoyer un tableau ou une liste de cases ou le
deplacement est possible, pour la surbrillance on verra ca plus tard avec une
fonction d'affichage specifique. */
int affichage_deplacements_possibles(Personnage *perso, Carte *c){ /* Met en surbrillance les cases disponibles pour un dplacement */
    int i;
    int pd_max_x = get_PD(perso);
    int pd_max_y = get_PD(perso);

    for(i=0;i<pd_max_x;i++){
        if(1!=0){
            /* ??? */
        }
    }
    return 0;
}

